//+------------------------------------------------------------------+
//|                                   Val MA2 signal(no repaint).mq4 |
//|                                                       Val_TLT_RU |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Val TLT RU"
#property link      "skype: pro.v.yermolenko"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1
//----
double CrossUp[];
double CrossDown[];
extern int FasterMode=3;
extern int FasterMA=  5;
extern int SlowerMode=3;
extern int SlowerMA=  7;
//0=sma, 1=ema, 2=smma, 3=lwma
//+------------------------------------------------------------------+

int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+

int deinit()
  {
//---- 
   return(0);
  }
//+------------------------------------------------------------------+

  int start() 
  {
   int limit, i, counter;
   double fasterMAnow, slowerMAnow, fasterMAprevious, slowerMAprevious, fasterMAafter, slowerMAafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- 
   if(counted_bars<0) return(-1);
//---- 
   if(counted_bars>0) counted_bars--;
//----
   limit=Bars-counted_bars;
     for(i=0; i<=limit; i++) 
     {
      counter=i;
      Range=0;
      AvgRange=0;
      for(counter=i ;counter<=i+9;counter++)
        {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
        }
      Range=AvgRange/10;
      fasterMAnow=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i+1);
      fasterMAprevious=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i+2);
      //fasterMAafter=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i-1);
//----
      slowerMAnow=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i+1);
      slowerMAprevious=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i+2);
      //slowerMAafter=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i-1);
        if ((fasterMAnow >= slowerMAnow) && (fasterMAprevious < slowerMAprevious))// && (fasterMAafter > slowerMAafter)) 
        {
         CrossUp[i]=Low[i] - Range*1;
        }
        else if ((fasterMAnow <= slowerMAnow) && (fasterMAprevious > slowerMAprevious))// && (fasterMAafter < slowerMAafter)) 
        {
            CrossDown[i]=High[i] + Range*1;
        }
        {
            if(PrevSignal <= 0 )
      {
        if(CrossDown[SIGNAL_BAR] > 0)
          {
            PrevSignal = 1;
            Alert("Val MA2 signal(no repaint) (", Symbol(), ", ", Period(), ")  -  BUY!!!");
          }
      }
    if(PrevSignal >= 0)
      {
        if(CrossUp[SIGNAL_BAR] > 0)
          {
            PrevSignal = -1;
            Alert("Val MA2 signal(no repaint) (", Symbol(), ", ", Period(), ")  -  SELL!!!");
          }
      }
      #define SIGNAL_BAR 2
        }
     }
   return(0);
  }
//----

//---- 

//+------------------------------------------------------------------+

